diff --git a/drivers/infiniband/hw/ocrdma/ocrdma_main.c b/drivers/infiniband/hw/ocrdma/ocrdma_main.c
index 873cc7f6fe61..54ac65e118e3 100644
--- a/drivers/infiniband/hw/ocrdma/ocrdma_main.c
+++ b/drivers/infiniband/hw/ocrdma/ocrdma_main.c
@@ -143,6 +143,50 @@ static const struct attribute_group ocrdma_attr_group = {
 	.attrs = ocrdma_attributes,
 };
 
+static const struct ib_device_ops ocrdma_dev_ops = {
+	.query_device = ocrdma_query_device,
+	.query_port = ocrdma_query_port,
+	.modify_port = ocrdma_modify_port,
+	.get_netdev = ocrdma_get_netdev,
+	.get_link_layer = ocrdma_link_layer,
+	.alloc_pd = ocrdma_alloc_pd,
+	.dealloc_pd = ocrdma_dealloc_pd,
+	.create_cq = ocrdma_create_cq,
+	.destroy_cq = ocrdma_destroy_cq,
+	.resize_cq = ocrdma_resize_cq,
+	.create_qp = ocrdma_create_qp,
+	.modify_qp = ocrdma_modify_qp,
+	.query_qp = ocrdma_query_qp,
+	.destroy_qp = ocrdma_destroy_qp,
+	.query_pkey = ocrdma_query_pkey,
+	.create_ah = ocrdma_create_ah,
+	.destroy_ah = ocrdma_destroy_ah,
+	.query_ah = ocrdma_query_ah,
+	.poll_cq = ocrdma_poll_cq,
+	.post_send = ocrdma_post_send,
+	.post_recv = ocrdma_post_recv,
+	.req_notify_cq = ocrdma_arm_cq,
+	.get_dma_mr = ocrdma_get_dma_mr,
+	.dereg_mr = ocrdma_dereg_mr,
+	.reg_user_mr = ocrdma_reg_user_mr,
+	.alloc_mr = ocrdma_alloc_mr,
+	.map_mr_sg = ocrdma_map_mr_sg,
+	.alloc_ucontext = ocrdma_alloc_ucontext,
+	.dealloc_ucontext = ocrdma_dealloc_ucontext,
+	.mmap = ocrdma_mmap,
+	.process_mad = ocrdma_process_mad,
+	.get_port_immutable = ocrdma_port_immutable,
+	.get_dev_fw_str = get_dev_fw_str,
+};
+
+static const struct ib_device_ops ocrdma_dev_srq_ops = {
+	.create_srq = ocrdma_create_srq,
+	.modify_srq = ocrdma_modify_srq,
+	.query_srq = ocrdma_query_srq,
+	.destroy_srq = ocrdma_destroy_srq,
+	.post_srq_recv = ocrdma_post_srq_recv,
+};
+
 static int ocrdma_register_device(struct ocrdma_dev *dev)
 {
 	ocrdma_get_guid(dev, (u8 *)&dev->ibdev.node_guid);
@@ -182,50 +226,10 @@ static int ocrdma_register_device(struct ocrdma_dev *dev)
 	dev->ibdev.phys_port_cnt = 1;
 	dev->ibdev.num_comp_vectors = dev->eq_cnt;
 
-	/* mandatory verbs. */
-	dev->ibdev.query_device = ocrdma_query_device;
-	dev->ibdev.query_port = ocrdma_query_port;
-	dev->ibdev.modify_port = ocrdma_modify_port;
-	dev->ibdev.get_netdev = ocrdma_get_netdev;
-	dev->ibdev.get_link_layer = ocrdma_link_layer;
-	dev->ibdev.alloc_pd = ocrdma_alloc_pd;
-	dev->ibdev.dealloc_pd = ocrdma_dealloc_pd;
-
-	dev->ibdev.create_cq = ocrdma_create_cq;
-	dev->ibdev.destroy_cq = ocrdma_destroy_cq;
-	dev->ibdev.resize_cq = ocrdma_resize_cq;
-
-	dev->ibdev.create_qp = ocrdma_create_qp;
-	dev->ibdev.modify_qp = ocrdma_modify_qp;
-	dev->ibdev.query_qp = ocrdma_query_qp;
-	dev->ibdev.destroy_qp = ocrdma_destroy_qp;
-
-	dev->ibdev.query_pkey = ocrdma_query_pkey;
-	dev->ibdev.create_ah = ocrdma_create_ah;
-	dev->ibdev.destroy_ah = ocrdma_destroy_ah;
-	dev->ibdev.query_ah = ocrdma_query_ah;
-
-	dev->ibdev.poll_cq = ocrdma_poll_cq;
-	dev->ibdev.post_send = ocrdma_post_send;
-	dev->ibdev.post_recv = ocrdma_post_recv;
-	dev->ibdev.req_notify_cq = ocrdma_arm_cq;
-
-	dev->ibdev.get_dma_mr = ocrdma_get_dma_mr;
-	dev->ibdev.dereg_mr = ocrdma_dereg_mr;
-	dev->ibdev.reg_user_mr = ocrdma_reg_user_mr;
-
-	dev->ibdev.alloc_mr = ocrdma_alloc_mr;
-	dev->ibdev.map_mr_sg = ocrdma_map_mr_sg;
-
 	/* mandatory to support user space verbs consumer. */
-	dev->ibdev.alloc_ucontext = ocrdma_alloc_ucontext;
-	dev->ibdev.dealloc_ucontext = ocrdma_dealloc_ucontext;
-	dev->ibdev.mmap = ocrdma_mmap;
 	dev->ibdev.dev.parent = &dev->nic_info.pdev->dev;
 
-	dev->ibdev.process_mad = ocrdma_process_mad;
-	dev->ibdev.get_port_immutable = ocrdma_port_immutable;
-	dev->ibdev.get_dev_fw_str     = get_dev_fw_str;
+	ib_set_device_ops(&dev->ibdev, &ocrdma_dev_ops);
 
 	if (ocrdma_get_asic_type(dev) == OCRDMA_ASIC_GEN_SKH_R) {
 		dev->ibdev.uverbs_cmd_mask |=
@@ -235,11 +239,7 @@ static int ocrdma_register_device(struct ocrdma_dev *dev)
 		     OCRDMA_UVERBS(DESTROY_SRQ) |
 		     OCRDMA_UVERBS(POST_SRQ_RECV);
 
-		dev->ibdev.create_srq = ocrdma_create_srq;
-		dev->ibdev.modify_srq = ocrdma_modify_srq;
-		dev->ibdev.query_srq = ocrdma_query_srq;
-		dev->ibdev.destroy_srq = ocrdma_destroy_srq;
-		dev->ibdev.post_srq_recv = ocrdma_post_srq_recv;
+		ib_set_device_ops(&dev->ibdev, &ocrdma_dev_srq_ops);
 	}
 	rdma_set_device_sysfs_group(&dev->ibdev, &ocrdma_attr_group);
 	dev->ibdev.driver_id = RDMA_DRIVER_OCRDMA;